package cokr.xit.fims.epst.dao;

import java.util.List;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.epst.EpostGdntc;
import cokr.xit.fims.epst.EpostQuery;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 전자우편 안내문 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-12-04	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("epostGdntcMapper")
public interface EpostGdntcMapper extends AbstractMapper {

	/**지정한 조건에 따라 전자우편 안내문 목록을 조회하여 반환한다.<br />
	 * @param req 전자우편 안내문 조회 조건
	 * @return 전자우편 안내문 목록
	 */
	List<DataObject> selectEpostGdntcList(EpostQuery req);

	/**지정한 조건에 따라 전자우편 안내문 객체들을 반환한다.
	 * @param req 전자우편 안내문 조회 조건
	 * @return 전자우편 안내문 객체 목록
	 */
	List<DataObject> selectEpostGdntcs(EpostQuery req);

	/**지정한 조건에 따라 부과제외 대장 객체의 마지막 1개를 반환한다.
	 * @param req 전자우편 안내문 조회 조건
	 * @return 전자우편 안내문 객체
	 */
	default DataObject selectEpostGdntcInfo(EpostQuery req) {
		// 사용 여부
		if (req.getUseYn() == null) {
			req.setUseYn("Y");
		}
		// 기본 정렬
		if (req.getOrderBy() == null) {
			req.setOrderBy("EG.GDNTC_ID DESC");
		}

		List<DataObject> epostGdntcs = selectEpostGdntcs(req);

		return !epostGdntcs.isEmpty() ? epostGdntcs.get(0) : null;
	}

	/**전자우편 안내문 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"epostGdcc" - 전자우편 안내문</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertEpostGdntc(EpostGdntc epostGdntc);

	/**전자우편 안내문 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"epostGdcc" - 전자우편 안내문</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateEpostGdntc(EpostGdntc epostGdntc);

	/**지정한 전자우편 안내문을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"epostGdcc" - 전자우편 안내문</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteEpostGdntc(EpostGdntc epostGdntc);

}
